Type.registerNamespace("SitefinityWebApp.FormFields.Designers");

SitefinityWebApp.FormFields.Designers.FormHiddenFieldDesigner = function (element) {
    /* Initialize Title fields */
    this._title = null;
    
    /* Initialize Description fields */
    this._hiddenValue = null;
    
    /* Initialize the meta field name TextBox used in form widget designers */
    this._metaFieldNameTextBox = null;

    /* Calls the base constructor */
    SitefinityWebApp.FormFields.Designers.FormHiddenFieldDesigner.initializeBase(this, [element]);
}

SitefinityWebApp.FormFields.Designers.FormHiddenFieldDesigner.prototype = {
    /* --------------------------------- set up and tear down --------------------------------- */
    initialize: function () {
        /* Here you can attach to events or do other initialization */
        SitefinityWebApp.FormFields.Designers.FormHiddenFieldDesigner.callBaseMethod(this, 'initialize');
    },
    dispose: function () {
        /* this is the place to unbind/dispose the event handlers created in the initialize method */
        SitefinityWebApp.FormFields.Designers.FormHiddenFieldDesigner.callBaseMethod(this, 'dispose');
    },

    /* --------------------------------- public methods ---------------------------------- */

    findElement: function (id) {
        var result = jQuery(this.get_element()).find("#" + id).get(0);
        return result;
    },

    /* Called when the designer window gets opened and here is place to "bind" your designer to the control properties */
    refreshUI: function () {
        var controlData = this._propertyEditor.get_control(); /* JavaScript clone of your control - all the control properties will be properties of the controlData too */

        /* RefreshUI Title */
        jQuery(this.get_title()).val(controlData.Title);

        /* RefreshUI Description */
        jQuery(this.get_hiddenValue()).val(controlData.HiddenValue);
    },

    /* Called when the "Save" button is clicked. Here you can transfer the settings from the designer to the control */
    applyChanges: function () {
        var controlData = this._propertyEditor.get_control();

        /* ApplyChanges Title */
        controlData.Title = jQuery(this.get_title()).val();

        /* ApplyChanges Description */
        controlData.HiddenValue = jQuery(this.get_hiddenValue()).val();

        controlData.MetaField.FieldName = this.get_metaFieldNameTextBox().get_value();
    },

    /* --------------------------------- event handlers ---------------------------------- */

    /* --------------------------------- private methods --------------------------------- */

    /* --------------------------------- properties -------------------------------------- */

    /* Title properties */
    get_title: function () { return this._title; }, 
    set_title: function (value) { this._title = value; },

    /* Description properties */
    get_hiddenValue: function () { return this._hiddenValue; },
    set_hiddenValue: function (value) { this._hiddenValue = value; },

    /* metaFieldNameTextBox properties */
    get_metaFieldNameTextBox: function () { return this._metaFieldNameTextBox; },
    set_metaFieldNameTextBox: function (value) { this._metaFieldNameTextBox = value; }
}

SitefinityWebApp.FormFields.Designers.FormHiddenFieldDesigner.registerClass('SitefinityWebApp.FormFields.Designers.FormHiddenFieldDesigner', Telerik.Sitefinity.Web.UI.ControlDesign.ControlDesignerBase);
